//  sig(x^4)*a + sig(x^3)*b + sig(x^2)*c = sig(x^2*y)
//  sig(x^3)*a + sig(x^2)*b + sig(x)*c   = sig(x*y)
//  sig(x^2)*a + sig(x)*b   + n*c        = sig(y)    
//========
#include <stdio.h>
int n,m;
float x[9],y[9],z[3],w[3];
main(int ac,char **av)
{
  int i;
  if(ac<2){ printf("\n\t **** minium 2 method *****\n");
            printf("\n\t Usage: mini2 2  or 3\n\n"); exit(0); }
  sscanf(av[1],"%d",&m);
  n=9;
  w[0]=1.23;  w[1]=2.34;  w[2]=3.45;  
  for(i=0;i<n;i++){
    x[i]=0.67*i;
    y[i]=w[0]+w[1]*x[i];
    if(m>2)y[i]+=w[2]*x[i]*x[i];
  }
  printf("start: "); for(i=0;i<m;i++)printf("%5.2f ",w[i]); printf("\n");
  mini2(x,y,n, z,m);
  printf("calcu: "); for(i=0;i<m;i++)printf("%5.2f ",z[i]); printf("\n");
}

mini2(float *xx,float *yy,int n, float *zz,int mini)
{
  int i;
  float sy,sxy,sx2y;
  float sx,sx2,sx3,sx4;
  float x,x2,x3,x4,y;
  float a[25][25],b[25];
  sy=sxy=sx2y=sx=sx2=sx3=sx4=0.;
  for(i=0;i<n;i++){
    x=xx[i]; y=yy[i];
    x2=x*x;  x3=x*x2;   x4=x2*x2;
    sy+=y;   sxy+=x*y;  sx2y+=x2*y;
    sx+=x;   sx2+=x2;   sx3+=x3;    sx4+=x4;
  }
  a[1][1]=n;   a[1][2]=sx;  a[1][3]=sx2;
  a[2][1]=sx;  a[2][2]=sx2; a[2][3]=sx3;
  a[3][1]=sx2; a[3][2]=sx3; a[3][3]=sx4;
  b[1]=sy;     b[2]=sxy;    b[3]=sx2y;
  solv(a,b,mini);
  for(i=0;i<mini;i++)z[i]=b[i+1];
}

solv(a,b,m)
float a[25][25],b[25]; int m;
{
  int i,j,k,l;
  float big,temp;

  for(i=1;i<m;i++){
    big=0.;
    for(k=i;k<=m;k++){
      temp=a[k][i];
      if(temp < 0.)temp=-temp;
      if(temp > big){ big=temp; l=k; }
    }
    if(big == 0.){
      for(k=1;i<=m;k++)b[k]=0;
      printf(" Zero determinant from SOLVE\n");
      return;
    }
    if(i != l){
      for(j=1;j<=m;j++){ temp=a[i][j]; a[i][j]=a[l][j]; a[l][j]=temp;}
      temp=b[i]; b[i]=b[l]; b[l]=temp;
    }
    big=a[i][i];
    for(j=i+1;j<=m;j++){
      temp=a[j][i]/big;
      b[j]-=temp*b[i];
      for(k=i;k<=m;k++)a[j][k]-=temp*a[i][k];
    }
  }
for(j=0;j<m;j++){for(i=0;i<m;i++)printf("%9.2f",a[j+1][i+1]); printf("\n"); }
  for(i=1;i<=m;i++){
    l=m+1-i;
    if(a[l][l]==0.){ b[l]=0.; continue; }
    temp=b[l];
    if(l != m)for(j=2;j<=i;j++){ k=m+2-j; temp-=a[l][k]*b[k]; }
    b[l]=temp/a[l][l];
  }
}

